// ga.h
// header file for mapping problem
// defines parameters and the defaults

// various kinds of crossover methods:
// PMX: partial matching cross-over
// OX: order crossover
#define PMX 1
#define OX 2
int CROSS_TYPE = PMX;

// various kinds of fitness methods:
// BOKHARI: if there is a direct edge map then 1, else 0
// MANHATTAN: sum of distances that edges must cover are base value
//            then figure variance
#define BOKHARI 0
#define MANHATTAN 1
int FITNESS_TYPE = MANHATTAN;

// Wheel weighting
#define NORMAL 1;
#define SQUARE 2;
#define CUBED 3;
int WHEEL_WEIGHT = NORMAL;

// how many passes should be make to randomize the genes
int MIX_FACTOR=3;

// What are the chances of a one-swap mutation
float MUT_FACTOR=0.01;

// What are the chances of a cross-over breeding
float CROSS_RATE=1.0;
