// test program for gene.hpp

#include<stdlib.h>
#include<iostream.h>
#include<fstream.h>
#include "meshmap.h"
#include "genemap.h"

extern "C"
{
  long random(void);
  void srandom(int);
}

int MESH_SIZE, MACH_SIZE, MACH_SIDE;
int CONNECTIVITY;
int MIX_FACTOR=3;
float MUT_FACTOR=0.01;
float CROSS_RATE=1.0;

main(int argc,char **argv)
{
  int MAX_POP;
  int fitness;

  if (argc != 5)
    {
      cout << "not right arguments" << endl;
      cout << "maxpop machine_side meshfile seed" << endl;
      exit(1);
    }

  MAX_POP = atoi(argv[1]);
  MACH_SIDE = atoi(argv[2]);
  MACH_SIZE = MACH_SIDE * MACH_SIDE;
  srandom(atoi(argv[4]));

  cout <<argv[0]<<" "<<argv[1]<<" "<<argv[2]<<" "<<argv[3]<<" "<<argv[4]<<endl;

  fstream meshfile(argv[3],ios::in);

  if (meshfile.bad())
    {
      cout << "Cannot open file" << argv[3] << endl;
      exit(1);
    }

  cout << "opened file"<<argv[3]<<endl;
  Meshmap mesh(meshfile);
  cout << "constructed mesh\n";
  mesh.Info();

  cout << endl << "Size of Machine: " << MACH_SIZE;

  Genemap alpha[MAX_POP],beta[MAX_POP];

  cout << endl << "Gene created" << endl << "Mesh size: " << MESH_SIZE;

  int count;
  for(count=0;(count<MAX_POP);count++)
    {
      cout << endl << count;
      alpha[count].Randomize();
      alpha[count].Info();
      alpha[count].Mutate();
      alpha[count].Info();
      alpha[count].Fitness(mesh);
      alpha[count].Info();
    }
  cout << endl << "Complete Stage Alpha" << endl;

  int a,b;
  for(count=0;(count<MAX_POP);count++)
    {
      a = ((int) random()) % MAX_POP;
      b = ((int) random()) % MAX_POP;

      cout << "\nCrossing "<<a<<" and "<<b<<"\n";
      beta[count].Cross(alpha[a], alpha[b]);
      beta[count].Info();
      beta[count].Fitness(mesh);
      beta[count].Info();
    }
  cout << endl << "Complete Stage Beta" << endl;

}
